; GUI #
;       FASM->64->OpenGl
include win64a.inc
; --------------- 
Wwd equ 432
Wht equ 432

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 + (sizeof WNDCLASSEX)
;	push	sizeof WNDCLASSEX       ;cbSize & style
	push	rax
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	Wht
	push	Wwd
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmTIMER        
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC  ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   )
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax; 
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax;  
	invoke	wglCreateContext,hDC;     OpenGL
	mov	hrc,rax
	invoke	wglMakeCurrent,hDC,eax;   
        invoke	SetTimer,hWin,10,25,0;  #10  50mSec
wmSIZE:; --------------- Resize the scene
        movzx	r8,r9w
	shr	r9,16
	invoke	glViewport,0,0
        jmp	wmBYE
wmTIMER:; No pending messages: draw the scene
; --------------- Display the scene
	movf4	xmm0,0.6
	xor	eax,eax
	movd	xmm1,eax
	movd	xmm2,eax
	movf4	xmm3,1.0
        invoke	glRotatef
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT
        invoke	glBegin,GL_QUADS
        movf4	xmm0,1.0
        movf4	xmm1,0.1
        movd    xmm2,eax
	invoke	glColor3f
        movf8	xmm0,-0.6
        movq    xmm1,rax
	xor	eax,eax
        movq    xmm2,rax
        invoke	glVertex3d
        movf4	xmm0,0.1
        movd    xmm1,eax
        movd    xmm2,eax
        invoke	glColor3f
        movf8	xmm0,0.6
        movf8	xmm1,-0.6
	xor	eax,eax
        movq    xmm2,rax
	invoke	glVertex3d
        movf4	xmm0,0.1
        movd    xmm1,eax
        movf4	xmm2,1.0
	invoke	glColor3f
        movf8	xmm0,0.6
        movq    xmm1,rax
	xor	eax,eax
        movq    xmm2,rax
	invoke	glVertex3d
        movf4	xmm0,1.0
        movd    xmm2,eax
        movf4	xmm1,0.1
	invoke	glColor3f
        movf8	xmm0,-0.6
        movf8	xmm1,0.6
	xor	eax,eax
        movq    xmm2,rax
	invoke	glVertex3d
	invoke	glEnd
;   
        invoke	SwapBuffers,hDC
wmBYE:	leave
	retn	
WndProc	endp
hDC	dq	?
hrc	dq	?
PixFrm	PIXELFORMATDESCRIPTOR <SIZEOF PixFrm,1,\
	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW,PFD_TYPE_RGBA,\
	16,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,PFD_MAIN_PLANE,0,0,0,0>
szClassName	db "Uncle Remus tales:#40 OpenGL",0
FileName	db "br_Rabbit3.cur",0
end